"""
Provides Polynomial, a very, very, very rudimentary class for polynomials
"""

class Polynomial:
    """
    A very, very, very rudimentary class for polynomials
    """
    def __init__(self, a):
        """
        Construct new Polynomial object with coefficients a (list)
        """
        self._a = a
        self._n = len(a) - 1


    def __str__(self):
        """
        Return a readable representation of the polynomial
        """
        str = "%f" % self._a[0]
        for i in range(1, self._n+1):
            if self._a[i]:
                if self._a[i] > 0:
                    str += " + "
                else:
                    str += " - "
                str += "%f * x**%d" % (abs(self._a[i]), i)
        str += "\n"
        return str


    def __call__(self, x):
        """
        Evaluate the Polynomial at x
        """
        # Use Horner's scheme:
        i = self._n
        res = self._a[i]
        while i > 0 :
            i -= 1
            res = res * x + self._a[i]
        return res


    def __add__(self, p):
        """
        Add another Polynomial to self

        Returns a new Polynomial object
        """
        aRes = []
        for i in range(min(self._n, p._n)+1):
            aRes.append(self._a[i] + p._a[i])
        if self._n > p._n:
            aRes.extend(self._a[p._n+1:])
        else:
            aRes.extend(p._a[self._n+1:])
        return Polynomial(aRes)
    
